> ## Documentation Index
> Fetch the complete documentation index at: https://docs.arrays.org/llms.txt
> Use this file to discover all available pages before exploring further.

# Crypto Token Kline data (no cursor pagination)

> [OpenAPI JSON Spec](/docs/output/v1_crypto_ohlcv_get.json)
Retrieve K-line (candlestick) chart data for a specified crypto token using a non-cursor gRPC endpoint to reduce latency.



## OpenAPI

````yaml /api-reference/openapi.json get /v1/crypto/ohlcv
openapi: 3.0.0
info:
  contact: {}
  description: >-
    Welcome to Arrays!


    Arrays is a unified financial data layer for both financial institutions and
    retail users, delivering comprehensive market data across crypto and equity
    markets. Our datasets cover fundamentals, ETFs, options, crypto, and more.


    Visit [arrays.org](https://arrays.org) to request an API key and start your
    free trial. You can explore our full API offerings in the documentation
    below.


    For any questions regarding APIs or pricing, please contact
    support@arrays.org.
  title: Arrays API
  version: '1.0'
servers:
  - url: https://data-tools.prd.arrays.org/api
security: []
paths:
  /v1/crypto/ohlcv:
    get:
      tags:
        - Crypto
      summary: Crypto Token Kline data (no cursor pagination)
      description: >-
        [OpenAPI JSON Spec](/docs/output/v1_crypto_ohlcv_get.json)

        Retrieve K-line (candlestick) chart data for a specified crypto token
        using a non-cursor gRPC endpoint to reduce latency.
      parameters:
        - description: 'Crypto token symbol, ex: BTC, ETH, SOL'
          in: query
          name: symbol
          required: true
          schema:
            type: string
        - description: Start time (Unix timestamp in seconds, must be > 0)
          in: query
          name: start_time
          required: true
          schema:
            type: integer
        - description: End time (Unix timestamp in seconds, must be > start_time)
          in: query
          name: end_time
          required: true
          schema:
            type: integer
        - description: Time interval for K-line data
          in: query
          name: interval
          required: true
          schema:
            type: string
            enum:
              - 1min
              - 2min
              - 3min
              - 5min
              - 10min
              - 15min
              - 30min
              - 45min
              - 1h
              - 2h
              - 4h
              - 6h
              - 8h
              - 12h
              - 1d
              - 3d
              - 1w
              - 1m
              - 3m
              - 6m
        - description: Maximum number of data points to return (default 500, max 10000)
          in: query
          name: limit
          schema:
            type: integer
      responses:
        '200':
          description: Successfully retrieved K-line data
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/model.APIResponse'
                  - properties:
                      data:
                        items:
                          $ref: '#/components/schemas/model.KlineData'
                        type: array
                    type: object
        '400':
          description: Invalid parameters
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/model.APIResponse'
                  - properties:
                      data:
                        $ref: '#/components/schemas/model.APIError'
                    type: object
        '500':
          description: Internal server error
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/model.APIResponse'
                  - properties:
                      data:
                        $ref: '#/components/schemas/model.APIError'
                    type: object
      security:
        - ApiKeyAuth: []
components:
  schemas:
    model.APIResponse:
      properties:
        data: {}
        error:
          $ref: '#/components/schemas/model.APIError'
        metadata: {}
        pagination: {}
        request_id:
          type: string
        success:
          type: boolean
      type: object
    model.KlineData:
      properties:
        price_close:
          type: number
        price_high:
          type: number
        price_low:
          type: number
        price_open:
          type: number
        time_close:
          type: integer
        time_open:
          type: integer
        time_period_end:
          type: string
        time_period_start:
          type: string
        trades_count:
          type: integer
        volume_traded:
          type: number
      type: object
    model.APIError:
      properties:
        code:
          example: RESOURCE_NOT_FOUND
          type: string
        details:
          items:
            $ref: '#/components/schemas/model.APIErrorDetail'
          type: array
        docs_url:
          type: string
        examples:
          items:
            type: string
          type: array
        hint:
          type: string
        message:
          example: The requested resource was not found.
          type: string
        suggestions:
          items:
            type: string
          type: array
      type: object
    model.APIErrorDetail:
      properties:
        field:
          type: string
        got:
          type: string
        reason:
          type: string
      type: object
  securitySchemes:
    ApiKeyAuth:
      description: 'API Key authentication. Example: "your-api-key-here"'
      in: header
      name: X-API-Key
      type: apiKey

````